<script type="text/javascript" src="/js/mootabs1.2.js"></script>
<script type="text/javascript" src="/js/cubix-ui-v1.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-button-v1.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-shadow-v1.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-popup-v3.0.source.js"></script>
<script type="text/javascript" src="/js/cubix-grid-v2.0.source.js"></script>

<script type="text/javascript">
Cubix.ready = function () {
	new Cubix.Shadow($('content'));

	var getFilterParams = function () {
		$$('form')[0].addEvent('submit', function(e){e.stop()});
		var uri = new URI('?' + $$('form')[0].toQueryString());
		return uri.get('data');
	};

	var getCountry = function () {
		return {
			country_id: $('country').get('value')
		}
	};
	
	var popup = new Cubix.Popup.Ajax({
		title: 'Add New Region',
		abar: [
			{ caption: 'Save', icon: 'accept', action: Cubix.Popup.Actions.SaveValid },
			{ caption: 'Close', icon: 'cancel', action: Cubix.Popup.Actions.Close }
		],
		width: 350
	});

	/* don't forget to assign Cubix.Grid.Instance when using Cubix.Popup.Actions.Save */
	var grid = Cubix.Grid.Instance = new Cubix.Grid('cx-grid', {
		identifier: { field: 'id' },
		preload: false,
		header: [
			{ title: 'ID', field: 'id', type: 'number', sortable: true, width: '40px' },
			{ title: 'State', field: 'state', type: 'string', sortable: true, width: '50px' },
			{ title: 'Title <img src="/img/famfamfa/<?= $this->lang() ?>.png"', field: 'title_<?= $this->lang() ?>', type: 'string', sortable: true },
			{ title: 'French', field: 'is_french', type: 'Toggle', format: { field: 'is_french', url: '/geography/regions/toggle-french?field=%f%&id=%i%' }, sortable: true, width: 65 },
			
			{ title: '', field: '', type: 'SeoButton', format: { primary_id: 'id', primary_title: 'title_<?= $this->lang() ?>', entity_slug: 'region' }, width: 16 }
		],
		sort: {
			field: 'title_<?= $this->lang() ?>',
			dir: 'asc'
		},
		actions: [ { type: 'remove', func: function (data) {
			if ( confirm('Are you sure you want to delete this row?') ) {
				this.overlay.disable();
				new Request({
					url: '<?= $this->baseUrl() ?>/geography/regions/remove?id=' + data.id,
					onSuccess: function (resp) {
						this.load();
					}.bind(this)
				}).send();
			}
		} }, { type: 'edit', func: function (data) {
			popup.setTitle('Edit Region');
			popup.load('<?= $this->baseUrl() ?>/geography/regions/edit?id=' + data.id + '&country_id=' + getCountry().country_id, function () {
				this.open();
			});
		} } ],
		data: new Cubix.Grid.Loader({ url: '<?= $this->baseUrl() ?>/geography/regions/data', params: getFilterParams })
	});

	grid.addEvent('loaded', function () {
		Cubix.Grid.DataTypes.SeoButton.init(this);
		Cubix.Grid.DataTypes.Toggle.init(this);
	});
	
	new Cubix.Button($('btn-create'), { onClick: function () {
		popup.load('<?= $this->baseUrl() ?>/geography/regions/create?country_id=' + getCountry().country_id, popup.open);
	}, icon: 'add', caption: 'Add New Region' });
	
	var fetchSelect = function () {
		var el = $$('select[name=country_id]')[0];
		el.set('disabled', 'disabled');
		new Request({
			url: '<?= $this->baseUrl() ?>/geography/countries/ajax?has_regions=0',
			method: 'get',
			onSuccess: function (resp) {
				resp = JSON.decode(resp).data;
				el.empty();
				new Element('option', {
					html: '- country -&nbsp;&nbsp;',
					value: ''
				}).inject(el);
				for ( var i = 0; i < resp.length; i++ ) {
					if ( resp[i].id ) {
						new Element('option', {
							html: resp[i].title + '&nbsp;&nbsp;',
							value: resp[i].id,
							selected: resp[i].id == <?= (int) Cubix_Application::getById()->country_id ?> ? 'selected' : null
						}).inject(el);
					}
					else {
						new Element('option', {
							html: resp[i].title + '&nbsp;&nbsp;',
							disabled: 'disabled'
						}).inject(el);
					}
				}

				el.set('disabled', '');
				el.fireEvent('change');
			}
		}).send();
	};
	
	fetchSelect();
	
	new Cubix.Button($('btn-refresh'), { onClick: function () {
		grid.load();
	}, icon: 'refresh', caption: 'Search', classes: '' });

	var clearForm = function() {
		var inputs = $$('.c-filter-form')[0].getElements('input');

		inputs.each(function(input) {
			var input_type = input.get('type');
			if ( input_type != 'hidden' ) {
				if ( input_type == 'text' ) {
					input.set('value', '');
				}
				else {
					input.set('checked', '');
				}
			}
		});

		var selects = $$('.c-filter-form')[0].getElements('select');

		selects.each(function(select) {
			select.set('value', '');
		});
	};

	var overlay = new Cubix.Overlay.Box(document.body, { showLoader: true });
	new Cubix.Button($('btn-sync'), { onClick: function () {
		overlay.disable();
		new Request({
			url: '<?= $this->baseUrl() ?>/geography/cities/sync?application_id=<?= Cubix_Application::getId() ?>&action_name=Regions',
			method: 'get',
			onSuccess: function (resp) {
                overlay.enable();
                resp = JSON.decode(resp);

                if(resp.status === 'error'){
                    alert('Error : ' + resp.message);
                }else{
                    alert(resp.message);
                }
			}
		}).send();
	}, icon: 'refresh', caption: 'Synchronize' });

	new Cubix.Button($('btn-reset'), { onClick: function () {
		clearForm();
		grid.load();
	}, icon: 'undo', caption: 'Reset Form', classes: 'ml20' });
	
	var initFormSubmit = function() {
		var inputs = $$('.c-filter-form')[0].getElements('input');

		inputs.each(function(input) {
			var input_type = input.get('type');

			if ( input_type != 'hidden' ) {
				if ( input_type == 'text' ) {
					input.addEvent('keyup', function(event) {
						if( event.key == 'enter' ) {
							grid.load();
						}
					});
				}
				else {
					input.addEvent('change', function(){
						grid.load();
					});
				}
			}
		});

		var selects = $$('.c-filter-form')[0].getElements('select');

		selects.addEvent('change', function(){
			grid.load();
		});
	};

	initFormSubmit();
};
</script>

<div class="form-common gray c-filter-form">
	<form>
		<div class="inner mb10">
			<label for="country">Country</label>
			<select name="country_id" id="country">
				<option value="">- country -&nbsp;&nbsp;</option>
			</select>
		</div>
		
		<div class="inner mb10">
			<label for="title">Title</label>
			<input type="text" class="txt" name="title" value="<?= $this->filter_params['title'] ?>" />
		</div>
		<div class="clear"></div>
		
		<a id="btn-refresh"></a>
		<a id="btn-reset"></a>
		<div class="clear"></div>
	</form>
</div><!-- form-common -->

<div class="mt10 fleft">
	<a id="btn-create"></a>
	<div class="clear"></div>
</div>

<div class="mt10 fleft">
	<a id="btn-sync"></a>
	<div class="clear"></div>
</div>

<div class="clear"></div>

<div id="ajax-dest">
	<div id="cx-grid">
	</div>
</div>
